package com.doverfuelingsolutions.issp.data

import com.doverfuelingsolutions.issp.utils.sp.SPUtil
import com.google.gson.Gson

class GlobalDataProvider<T>(private var value: T, private val sp: String = "") {

    companion object {
        private val gson = Gson()
    }

    private val cls = value!!::class.java
    private val stringDefaultValue = gson.toJson(value, cls)

    init {
        if (sp.isNotEmpty()) {
            val spValue = SPUtil.getString(sp, stringDefaultValue)
            if (!spValue.isBlank()) value = gson.fromJson(spValue, cls)
        }
    }

    fun get() = value

    fun set(v: T) {
        value = v
        if (sp.isNotEmpty()) {
            SPUtil.putString(sp, gson.toJson(v, cls))
        }
    }
}