package com.doverfuelingsolutions.issp.view.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.os.bundleOf
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.fragment.app.setFragmentResult
import androidx.fragment.app.viewModels
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import com.doverfuelingsolutions.issp.DFSApplication
import com.doverfuelingsolutions.issp.R
import com.doverfuelingsolutions.issp.data.GlobalData
import com.doverfuelingsolutions.issp.databinding.FragmentSearchTypeBinding

class FragmentSelect : Fragment(),
    View.OnClickListener {

    private val viewModel: SearchTypeViewModel by viewModels()

    private lateinit var binding: FragmentSearchTypeBinding

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        if (!this::binding.isInitialized) {
            binding = DataBindingUtil.inflate(inflater, R.layout.fragment_search_type, container, false)
            binding.lifecycleOwner = this
            binding.viewModel = viewModel

            binding.chooseOil.setOnClickListener(this)
            binding.chooseNozzle.setOnClickListener(this)
        }
        return binding.root
    }

    override fun onClick(v: View?) {
        when (v) {
            binding.chooseNozzle -> setFragmentResult(
                FragmentConstants.fragmentEvent,
                bundleOf(
                    Pair(FragmentConstants.eventType, FragmentConstants.eventSearchBy),
                    Pair(FragmentConstants.searchType, FragmentConstants.typeNozzle)
                )
            )
            binding.chooseOil -> setFragmentResult(
                FragmentConstants.fragmentEvent,
                bundleOf(
                    Pair(FragmentConstants.eventType, FragmentConstants.eventSearchBy),
                    Pair(FragmentConstants.searchType, FragmentConstants.typeOilName)
                )
            )
        }
    }

    class SearchTypeViewModel : ViewModel() {
        val deviceNum = MutableLiveData(GlobalData.serialNumber.get())
        val version: MutableLiveData<String> by lazy {
            val pm = DFSApplication.instance.applicationContext.packageManager
            val info = pm.getPackageInfo(
                DFSApplication.instance.applicationContext.packageName,
                android.content.pm.PackageManager.GET_ACTIVITIES
            )
            MutableLiveData(info.versionName)
        }
    }
}